/**================================================================================================
Hochschule Luzern - Technik & Architektur                                  Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                    http://hslu.ximit.ch
---------------------------------------------------------------------------------------------------
Name        : Uebung_3-1.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-09-30v1.0
Description : Liste mit Namen/Vornamen
              Schreiben Sie ein Programm, welches in einer einfach verketteten Liste eine
			  beliebige Anzahl von Namen/Vornamen festhlt.
			  Allozieren Sie den Speicherplatz fr Ihre Daten dynamisch.
=================================================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLEN 100

typedef struct name* namePtr_t;
typedef struct name {
	char* lastname;
	char* firstname;
	namePtr_t next;
} name_t;

/**
 * Add a new Name to the List
 * @param parent Parent Object
 * @param firstname Firstname
 * @param lastname Lastname
 * @return Pointer to the current Name
 */
namePtr_t addName(namePtr_t parent, char* firstname, char* lastname)
{
	if (parent == NULL) {
		// add new
		parent = (namePtr_t) malloc(sizeof(name_t));	// alloc memory for this new object
		parent->firstname = strdup(firstname);			// copy firstname (alloc mem & copy string)
		parent->lastname = strdup(lastname);			// copy lastname (alloc mem & copy string)
		parent->next = NULL;
	}
	else 
	{
		parent->next = addName(parent->next, firstname, lastname); // rekursiv add, save pointer to next object
	}
	// return parent (root) object
	return parent;
}

/**
 * Print all names
 * @param n Root Object of the Name List
 */
void printName(namePtr_t n)
{
	if (n != NULL)
	{
		printf("FirstName: %s\nLastName:  %s\n\n", n->firstname, n->lastname);
		printName(n->next);
	}
}


/**
 * The main procedure to run the application.
 * @param argc Number of command line arguments
 * @param argv The forwarded command line arguments
 * @return Application return (error) code
 */
int main(int argc, char** argv)
{
	namePtr_t root = NULL;

	char firstname[MAXLEN], lastname[MAXLEN];

	printf("'.' as Firstname will abort the input...\n");
	do
	{
		printf("Firstname: ");
		scanf("%s", firstname);
		fflush(stdin); //flushes the input stream and gets rid of '\n'
		if (firstname[0] != '.') {
			printf("Lastname:  ");
			scanf("%s", lastname);
			fflush(stdin); //flushes the input stream and gets rid of '\n'
			//add new name
			root = addName(root, firstname, lastname);
		}
	} while (firstname[0] != '.');


	// PrintOut
	printf("\n\nEntered Names:\n");
	printName(root);



	
	fflush(stdin); //flushes the input stream and gets rid of '\n'
	printf("\n\nPress [Enter] to exit...");
	getchar();
	return(EXIT_SUCCESS);
}

